Name:           ffcall
Version:        2.4
Release:    1%{?dist}
Summary:        Libraries for foreign function call interfaces

License:        GPL-2.0-or-later
URL:            https://www.gnu.org/software/libffcall/
Source0:        https://ftp.gnu.org/gnu/libffcall/lib%{name}-%{version}.tar.gz
Patch0:         configure.patch

BuildRequires:  gcc
BuildRequires:  gnulib-devel
BuildRequires:  make

%description
This is a collection of four libraries which can be used to build
foreign function call interfaces in embedded interpreters.  The four
packages are:
 - avcall: calling C functions with variable arguments
 - vacall: C functions accepting variable argument prototypes
 - trampoline: closures as first-class C functions
 - callback: closures with variable arguments as first-class C functions
   (a reentrant combination of vacall and trampoline)

%package devel
Summary:        Files needed to develop programs with %{name}
License:        GPL-2.0-or-later AND (GPL-2.0-or-later OR GFDL-1.2-or-later)
Requires:       %{name} = %{version}-%{release}

%description devel
Files needed to develop programs with %{name}.

%package static
Summary:        Static libraries for foreign function call interfaces
Requires:       %{name}-devel = %{version}-%{release}

%description static
Static libraries for foreign function call interfaces.

%prep
%autosetup -n lib%{name}-%{version} -p1

%build
%configure

make # %{?_smp_mflags}

%install
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_mandir}
%make_install
rm -fr %{buildroot}%{_datadir}/html
rm -f %{buildroot}%{_libdir}/*.la

chmod a+x %{buildroot}%{_libdir}/lib*.so.*

mkdir -p %{buildroot}%{_rpmconfigdir}/macros.d
cat > %{buildroot}%{_rpmconfigdir}/macros.d/macros.%{name} << EOF
%%ffcall_arches %{ffcall_arches}
EOF

pushd %{buildroot}%{_mandir}/man3
for page in *; do
  mv $page %{name}-$page
done
popd

%files
%license COPYING
%doc README NEWS
%{_libdir}/libavcall.so.1*
%{_libdir}/libcallback.so.1*
%{_libdir}/libffcall.so.0*
%{_libdir}/libtrampoline.so.1*

%files devel
%doc avcall/avcall.html
%doc callback/callback.html
%doc callback/trampoline_r/trampoline_r.html
%doc trampoline/trampoline.html
%doc vacall/vacall.html
%{_includedir}/avcall.h
%{_includedir}/callback.h
%{_includedir}/ffcall*.h
%{_includedir}/trampoline.h
%{_includedir}/vacall*.h
%{_libdir}/libavcall.so
%{_libdir}/libcallback.so
%{_libdir}/libffcall.so
%{_libdir}/libtrampoline.so
%{_mandir}/man3/ffcall*
%{_rpmconfigdir}/macros.d/macros.%{name}

%files static
%{_libdir}/*.a

%changelog
* Mon Apr 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.4-1
- initial build
